/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Martin Rexa
 */

package cz.xelfi.quoridor.statistics;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Martin Rexa
 */
public class EloTest extends Object {

    public EloTest() throws Exception {
    }

    @Test public void testEloList() throws Exception {
        EloList eloList = new EloList();
        eloList.putResult("p1", "p2");
        assertFalse("empty list", eloList.getFinalList().isEmpty());
        eloList.putResult("p3", "p4");
        assertTrue("wrong list", eloList.getFinalList().get(0).getElo().equals(eloList.getFinalList().get(1).getElo()));
        eloList.putResult("p2", "p1");
        eloList.putResult("p2", "p1");
        eloList.putResult("p2", "p1");
        assertTrue("wrong list", eloList.getFinalList().get(0).player.equals("p2"));
    }

    @Test public void testEloResults() throws Exception {
        EloList eloList = new EloList();
        setTestPlayer(eloList, "p1", 1335, 120);
        setTestPlayer(eloList, "p2", 1380, 20);
        setTestPlayer(eloList, "p3", 1264, 110);
        setTestPlayer(eloList, "p4", 1281, 140);
        printList(eloList);
//        eloList.putResult("p1", "p2");
        eloList.putResult("p1", "p3");
        eloList.putResult("p1", "p4");
        printList(eloList);
        eloList.putResult("p2", "p1");
        eloList.putResult("p1", "p2");
        printList(eloList);
    }

    private void setTestPlayer(EloList eloList, String player, double elo, int games){
        eloList.players.put(player, elo);
        eloList.playerGames.put(player, games);
    }

    private void printList(EloList eloList){
        for(EloEntry entry: eloList.getFinalList()){
            System.out.println(entry);
        }
        System.out.println("------------");
    }

}
